/*-------------------------------------------------------------------------
*
* Copyright (c) 2004-2008, PostgreSQL Global Development Group
*
* IDENTIFICATION
*   $PostgreSQL: pgjdbc/org/postgresql/jdbc2/AbstractJdbc2Statement.java,v 1.115 2009/09/26 15:21:21 jurka Exp $
*
*-------------------------------------------------------------------------
*/
/*
 * $URL$
 * $Id$
 * $Revision$
 */
package org.postgresql.core;

import java.sql.SQLException;

/**
 * The implementation of {@link Runnable} to use with method that
 * returns data or throws SQLException.
 *
 * <i>The PostgreSQL driver is designed to be used on old Java
 * based systemes, so API can't have {@code java.util.concurent}
 * package</i>
 *
 * @author Radosław Smogura (rsmogura@softperience.pl)
 */
public abstract class PostgreSqlRunnable implements Runnable{
    private SQLException sqlException;
    private Object result;

    public abstract Object runSql() throws SQLException;

    public final void run() {
        try {
            result = runSql();
        }catch(SQLException sqle) {
            sqlException = sqle;
        }
    }

    public Object getResult() {
        return result;
    }

    public SQLException getSqlException() {
        return sqlException;
    }
}
